---
title: 'MessagePort: message event'
slug: Web/API/MessagePort/message_event
tags:
  - Event
---
<div>{{APIRef}}</div>

<p>The <code>message</code> event is fired on a {{domxref('MessagePort')}} object when a message arrives on that channel.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{domxref("MessageEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td><code><a href="/en-US/docs/Web/API/MessagePort/onmessage">onmessage</a></code></td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<p>Suppose a script creates a <code><a href="/en-US/docs/Web/API/MessageChannel">MessageChannel</a></code> and sends one of the ports to a different browsing context, such as another <code><a href="/en-US/docs/Web/HTML/Element/iframe">&lt;iframe&gt;</a></code>, using code like this:</p>

<pre class="brush: js">const channel = new MessageChannel();
const myPort = channel.port1;
const targetFrame = window.top.frames[1];
const targetOrigin = 'https://example.org';

const messageControl = document.querySelector('#message');
const channelMessageButton = document.querySelector('#channel-message');

channelMessageButton.addEventListener('click', () =&gt; {
    myPort.postMessage(messageControl.value);
})

targetFrame.postMessage('init', targetOrigin, [channel.port2]);</pre>

<p>The target can receive the port and start listening for messages on it using code like this:</p>

<pre class="brush: js">window.addEventListener('message', (event) =&gt; {
    const myPort = event.ports[0];

    myPort.addEventListener('message', (event) =&gt; {
        received.textContent = event.data;
    });

    myPort.start();
});</pre>

<p>Note that the listener must call <code><a href="/en-US/docs/Web/API/MessagePort/start">MessagePort.start()</a></code> before any messages will be delivered to this port. This is only needed when using the <code><a href="/en-US/docs/Web/API/EventTarget/addEventListener">addEventListener()</a></code> method: if the receiver uses <code><a href="/en-US/docs/Web/API/MessagePort/onmessage">onmessage</a></code> instead, <code>start()</code> is called implicitly:</p>

<pre class="brush: js">window.addEventListener('message', (event) =&gt; {
    const myPort = event.ports[0];

    myPort.onmessage = (event) =&gt; {
        received.textContent = event.data;
    };
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', 'indices.html#event-message')}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MessagePort.message_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Related events: <code><a href="/docs/Web/API/MessagePort/messageerror_event">messageerror</a></code>.</li>
 <li><a href="/en-US/docs/Web/API/Channel_Messaging_API/Using_channel_messaging">Using channel messaging</a></li>
</ul>
